C        PROGRAM PLATE2
C
C       ===================================================
C       Purpose: This program computes growth rate for
C       plate type particles with a capillarity correciton 
C       term. Interface kinetics is also considered.
C       ===================================================
C
C       Copyright Pedro Rivera and H. K. D. H. Bhadeshia,
C       University of Cambridge, 1999
C

       IMPLICIT DOUBLE PRECISION (A-H,O-Z),INTEGER(I,J,L)
       DOUBLE PRECISION PEC(6053), N1(6053), N2(6053)
       DOUBLE PRECISION DPEC(20), DN1(20), DN2(20), A(3),B(3)
       DOUBLE PRECISION JN1,JN2,S1P,S2P,K,KP,KM
       DOUBLE PRECISION S1PM,S2PM,S1PP,S2PP
       DOUBLE PRECISION DS1P,DS2P,DK,DKP
       DOUBLE PRECISION JJN1,JJN2,FAC
       PI = 3.141592654
       IN1 = 1             
       OU2 = 2
      OPEN(UNIT = IN1,FILE='indat11.d')
      OPEN(UNIT = OU2,FILE='res1.d')

       READ(IN1,*) Q
      DO 10 I=1,4000
       READ(IN1,*) PEC(I), N1(I), N2(I)
10    CONTINUE
      DO 12 I=1,19
       READ(IN1,*) DPEC(I), DN1(I), DN2(I)
12    CONTINUE

      P=1.0D-1

      DO 13 L=1,99
      O=0.0d0+L*0.01
      IF (O.LE.0.6) THEN
      P=1.0D-1
      DP=1.0D-2
      ENDIF
      
      DO 20 I=0,5000

      IF (O.LE.0.6) THEN
       P=1.0D-1
      ENDIF
       DP=1.0D-2
      R = 10**(0.001*I)
      II=0
      JJ=0
23    IF (P-DP.LE.1.0D-10) THEN
       DP=P/2.0D0
       PP=P+DP
       PM=P-DP
       P=(PM+PP)/2.0D0
      ELSE
       PP=P+DP
       PM=P-DP
       P=(PM+PP)/2.0D0
      ENDIF
      CALL ERROR(P**0.50D0,ERP)
      CALL ERROR(PP**0.50D0,ERPP)
      CALL ERROR(PM**0.50D0,ERPM)
      ERP=1.0D0-ERP
      ERPP=1.0D0-ERPP
      ERPM=1.0D0-ERPM
      DO 25 J=1,4000
        IF ((PEC(J).LE.P).AND.(PEC(J+1).GE.P)) THEN
         JN1=N1(J)+((N1(J+1)-N1(J))/
&        (PEC(J+1)-PEC(J)))*(P-PEC(J))
         JJN1=JN1
         JN2=N2(J)+((N2(J+1)-N2(J))/
&        (PEC(J+1)-PEC(J)))*(P-PEC(J))
         JJN2=JN2
         S1P=(1.0D0/(2.0d0*P))*JN1-1.0D0
         S2P=(1.0D0/(2.0d0*P))*JN2-1.0D0
         GOTO 30
        ENDIF
25     CONTINUE

30     DO 35 J=1,4000
        IF ((PEC(J).LE.PP).AND.(PEC(J+1).GE.PP)) THEN
         JN1=N1(J)+((N1(J+1)-N1(J))/
&        (PEC(J+1)-PEC(J)))*(PP-PEC(J))
         JN2=N2(J)+((N2(J+1)-N2(J))/
&        (PEC(J+1)-PEC(J)))*(PP-PEC(J))
         S1PP=(1.0D0/(2.0d0*PP))*JN1-1.0D0
         S2PP=(1.0D0/(2.0d0*PP))*JN2-1.0D0
         GOTO 40
        ENDIF
35     CONTINUE 
40     DO 45 J=1,4000
        IF ((PEC(J).LE.PM).AND.(PEC(J+1).GE.PM)) THEN
         JN1=N1(J)+((N1(J+1)-N1(J))/
&        (PEC(J+1)-PEC(J)))*(PM-PEC(J))
         JN2=N2(J)+((N2(J+1)-N2(J))/
&        (PEC(J+1)-PEC(J)))*(PM-PEC(J))
         S1PM=(1.0D0/(2.0d0*PM))*JN1-1.0D0
         S2PM=(1.0D0/(2.0d0*PM))*JN2-1.0D0
         GOTO 50
        ENDIF
45      CONTINUE



50     K=(PI*P)**0.50D0*DEXP(P)*ERP*(1.0D0+
&      (1.0D0/R)*(P/Q)*O*S1P+(1.0D0/R)*O*S2P)-O
       KP=(PI*PP)**0.50D0*DEXP(PP)*ERPP*(1.0D0+
&      (1.0D0/R)*(PP/Q)*O*S1PP+(1.0D0/R)*O*S2PP)-O
       KM=(PI*PM)**0.50D0*DEXP(PM)*ERPM*(1.0D0+
&      (1.0D0/R)*(PM/Q)*O*S1PM+(1.0D0/R)*O*S2PM)-O

       IF ((K.GT.0.0D0).AND.(KP.GT.0.0D0).AND.
&       (KM.GT.0.0D0)) THEN
        II=II+1
        IF (II.EQ.1) THEN
          A(II)=P
        ENDIF
        IF (II.EQ.2) THEN
          A(II)=P
        ENDIF
        IF (II.EQ.3) THEN
          A(II)=P
        ENDIF
        IF ((II.EQ.3).AND.(A(1).EQ.A(3))) THEN
          GOTO 20
        ENDIF
        IF (II.EQ.3) THEN
          II=0
        ENDIF
        IF (KM.LT.K) THEN
         P=P-DP
        ELSE
         P=P+DP
        ENDIF
       GOTO 60
       ENDIF
       IF ((K.LT.0.0D0).AND.(KP.LT.0.0D0).AND.
&       (KM.LT.0.0D0)) THEN
        JJ=JJ+1
        IF (JJ.EQ.1) THEN
          B(JJ)=P
        ENDIF
        IF (JJ.EQ.2) THEN
          B(JJ)=P
        ENDIF
        IF (JJ.EQ.3) THEN
          B(JJ)=P
        ENDIF
        IF ((JJ.EQ.3).AND.(B(1).EQ.B(3))) THEN
          GOTO 20
        ENDIF
C        write(*,*)b(1),b(2),b(3),jj
        IF (JJ.EQ.3) THEN
          JJ=0
        ENDIF
        IF (KP.GT.K) THEN
         P=P+DP
        ELSE
         P=P-DP
        ENDIF
       GOTO 60       
       ENDIF
       DP=DP/2.0D0
       IF (((K.GT.0.0D0).AND.(KP.LT.0.0D0)).OR.
&       ((K.LT.0.0D0).AND.(KP.GT.0.0D0))) THEN
        P=P+DP
       ELSE
        P=P-DP
       ENDIF
60    IF (DP.GE.1D-12) THEN
        GOTO 23
      ENDIF


C =======================================================
C CALCULATION OF THE FIRST ORDER DERIVATIVE
c        write(*,200)r,p,dp

       DS1P=(S1pp-s1pm)/(pp-pm)
       DS2P=(S2pp-s2pm)/(pp-pm)

95      FAC=(PI*P)**0.50D0*DEXP(P)*ERP   
        DK=(FAC**2.0D0)*(1.0D0/R)*(P*DS1P/Q
&       -S2P/P+DS2P)+FAC/(2.0d0*P)+FAC-1.0d0
       IF (((DKP.LT.0).AND.(DK.GT.0)).OR.
&      ((DKP.GT.0).AND.(DK.LT.0))) THEN
        RRR=(R+10**(0.001*(I-1)))/2.0D0
       write(OU2,200) o,RRR,p      
        GOTO 13
       ENDIF
       DKP=DK
20    CONTINUE

13    CONTINUE

200    FORMAT(1X,4D15.5)
999    STOP
       END
        
        SUBROUTINE ERROR(X,ERR)
C
C       =========================================
C       Purpose: Compute error function erf(x)
C       Input:   x   --- Argument of erf(x)
C       Output:  ERR --- erf(x)
C       =========================================
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        EPS=1.0D-15
        PI=3.141592653589793D0
        X2=X*X
        IF (DABS(X).LT.3.5D0) THEN
           ER=1.0D0
           R=1.0D0
           DO 10 K=1,50
              R=R*X2/(K+0.5D0)
              ER=ER+R
              IF (DABS(R).LE.DABS(ER)*EPS) GO TO 15
10         CONTINUE
15         C0=2.0D0/DSQRT(PI)*X*DEXP(-X2)
           ERR=C0*ER
        ELSE
           ER=1.0D0
           R=1.0D0
           DO 20 K=1,12
              R=-R*(K-0.5D0)/X2
20            ER=ER+R
           C0=DEXP(-X2)/(DABS(X)*DSQRT(PI))
           ERR=1.0D0-C0*ER
           IF (X.LT.0.0) ERR=-ERR
        ENDIF
        RETURN
        END


